/******************************* cgmparse.h *********************************/

#define MAXCGMCHAR 515  /* max character string length, max value = 32767 */

extern int cgm_parse_error;
extern int cgm_color_mode_in;
extern int cgm_color_index_precision;
extern int cgm_color_precision;



struct cgm_head
{
    int  class;      /* cgm element class */
    int  id;         /* cgm element id */
    int  length;     /* num bytes left in current partition */
    int  partition;  /* partition flag, 0 = last partition, 1 = more to 
                        follow */
    int  odd;        /* odd or even number to bytes, 0 = even, 1 = odd */
};

extern struct cgm_head cgm_header;


extern char cgm_cbuffer[];
extern FILE  *cgmsrc;
extern int cgm_done;

void cgm_read_element_header(void);
unsigned int cgm_read_string(void);
int cgm_skipdata(void);
unsigned int cgm_read_integers(unsigned maxsize,int *buffer);
long cgm_onerval(void);
int cgm_oneival(void); 
int _cgm_oneival(void);
int cgm_onebval(void);
int cgm_read_color_index(void);
int cgm_read_rgb_color( int *rgb);


#define FixedtoFloat(op)  1.525879E-5*op


