/********************************** demo.c **********************************/

#include <stdio.h>
#include "cgm.h"


#define MUNIT 0L  //Abstract 

#define cgm_aux_color(color)    cgm_color(AUXCOLR,color)
#define cgm_line_color(color)   cgm_color(LINECOLR,color)
#define cgm_marker_color(color) cgm_color(MARKERCOLR,color)
#define cgm_text_color(color)   cgm_color(TEXTCOLR,color)
#define cgm_fill_color(color)   cgm_color(FILLCOLR,color)
#define cgm_edge_color(color)   cgm_color(EDGECOLR,color)


#define MAXCOLOR 16



    int vga[] = {   255,255,255,    /*  0  white     */
                    0,0,0,          /*  1  black     */
                    0,102,133,      /*  2  true blue */
                    0,161,0,        /*  3  green     */
                    182,0,0,        /*  4  red       */
                    255,36,0,       /*  5  orange    */
                    202,102,36,     /*  6  brown      */
                    113,0,113,      /*  7  violet     */
                    0,236,255,      /*  8  sky blue   */
                    255,212,0,      /*  9  yellow     */
                    255,113,174,    /* 10  light magnt */
                    82,82,82,       /* 11  50 % gray   */
                    128,128,128,    /* 12  25 % gray   */
                    40,40,40,       /* 13  75 % gray   */
                    0,0,128,        /* 14  dark blue   */
                    0,0,255};       /* 15  Intense blue */

int mincolor[] = {0,0,0};
int maxcolor[] = {255,255,255};


char G1teststr[] = {0xA1,0xA2,0xA3,0xA4,0xA5,0};

char *font_list[] = {"Font 1","Font 2","Font 3","Font 4",NULL};

/* use two character sets */
/* index 1 = ISO 8859-1 G0-set 4/1 to 7/14  */
/* index 2 = ISO 8859-1 G1-set 10/0 to 15/15 */
/* "ANSI 8-bit" = G0 + G1 character sets of ISO 8859-1 */

CHARSET  charlist[] = {G94,"B",
                       G96,"A",
                       0,NULL};

int main(void)
{
    int k,j,color,maxX,maxY,dx,dy,nx,ny,bdx,bdy,bnx,bny,cx,cy;
    int buf[64];
    maxX = 32000; /* 10 " */
    maxY = 24000; /* 7.5 " */
    nx = 8;
    ny = 6;
    dx = maxX/nx;
    dy = maxY/ny;


    k = cgm_begin_metafile("demo.cgm",          /* Output file name */

                           "Demo CGM Metafile", /* Begin Metafile string */

                            "KIS CGM v1.0",     /* Metafile Descr. string */

                            MAXCOLOR -1,        /* Max color index */

                            mincolor,           /* rgb min value extent */

                            maxcolor,          /*  rgb max value extent  */

                            font_list,          /* pointer to font font array,
                                                   if the first string is zero
                                                   length ("\0") no font list
                                                   element is writen to the
                                                   metafile */

                            charlist,            /* character set list */

                            BASIC8);             /* 8-bit codes, no escape
                                                   sequence for selection of
                                                    G1-set */
    if (k)
    {
        printf(" Metafile Open Error %d\n",k);
        return(1);
    }

    cgm_begin_picture("Picture 1",              /* Begin picture string */

                            MUNIT,              /* <= 0 is abstract, otherwise
                                                   fixed point meteric scaling
                                                   factor. */

                             0,0,maxX,maxY,     /* VDC extent */


                             &vga[0]);          /* pointer to background color
                                                   triple (RGB). If null the
                                                   default color is used
                                                   ( no element is written) */

    cgm_color_table( 1,MAXCOLOR -1,&vga[3]); /* should be the first element after
                                         begin picture if the default colors
                                         are not used (0 = default bg, 1 = 
                                         default drawing color      */

    cgm_char_set_index(1);            /* set to 8-bit ASCII  4/1 to 7/14   */
    cgm_alt_char_set_index(2);        /* set to 8-bit ASCII  10/0 to 15/15 */

    cgm_transparency(ON);             /* should set on, however the graphics 
                                         systems i have seen generate hatch
                                         fills as if transrency was off */
    cgm_clip(OFF);                    /* set to off if cliping is not
                                         required , graphics programs may not 
                                         support this element */

    cgm_edge_vis(ON);
    cgm_edge_width(1);
    cgm_edge_type(SOLID);

    cgm_edge_color(15);

    cgm_interior_style(EMPTY);
    cgm_rectangle(0,0,maxX,maxY);


    cgm_line_color(15);

    cgm_line_type(DOT);
    cgm_line_width(1);
    /* would be nice if disjline used two pt arguments */

    cgm_begin_disjline(0,dy);
    cgm_disjline(maxX,dy);
    for ( j = 2; j < ny; j++)
    {
       cgm_disjline(0,dy*j);
       cgm_disjline(maxX,dy*j); 
    }
    cgm_end_disjline();

    cgm_begin_disjline(dx,0);
    cgm_disjline(dx,maxY);
    for ( j = 2; j < nx; j++)
    {
       cgm_disjline(dx*j,0);
       cgm_disjline(dx*j,maxY); 
    }
    cgm_end_disjline();

    /* box 1: test 16 colors */
    bnx = 4;
    bny = 4;
    bdx = dx/bnx;
    bdy = dy/bnx;
    cgm_edge_vis(OFF);
    cgm_interior_style(SOLID);
    color = 0;
    for( j = 0; j < bnx;j++)
    {
        for(k = 0; k < bny; k++)
        {

            cgm_fill_color(color++);
            cgm_rectangle(j*bdx,k*bdy,(j+1)*bdx,(k+1)*bdy);
        }
    }


    /* box 2: test hatch */
    bnx = 6;
    bdx = dx/bnx;
    cgm_interior_style(HATCH);
    cgm_edge_vis(ON);

    cgm_fill_color(1);
    cgm_edge_color(1);

    for(k = 0; k < bnx; k++)
    {
         cgm_hatch_index(k+1);
         cgm_rectangle(dx + k*bdx,0, dx + (k+1)*bdx,dy);
    }

    /* box 3: test line style (1 - 5) */
    bny = 5;
    bdy = dy/(bny +1);

    cgm_line_color(3);

    cgm_line_width(50);

    for(k = 0; k < bny; k++)
    {
         cgm_line_type(k+1);
         cgm_line( 2*dx + dx/8, bdy*(k +1), 3*dx - dx/8,bdy*(k +1));
    }



    /* box 4: test marker style (1 - 5) */
    bny = 5;
    bdy = dy/(bny +1);

    cgm_marker_color(4);

    cgm_marker_size(bdy/2);

    for(k = 0; k < bny; k++)
    {
         cgm_marker_type(k+1);
         cgm_marker( 3*dx + dx/2,bdy*(k +1));
    }


    /* box 5: test polygon */

    cgm_edge_color(5);
    cgm_fill_color(6);

    cgm_interior_style(SOLID);
    cgm_edge_width(25);
    cgm_begin_polygon(4*dx + dx/4,dy/4);
    cgm_polygon(5*dx  - dx/4,dy/4);
    cgm_polygon(5*dx  - dx/2,dy - dy/4);
    cgm_polygon(4*dx  + dx/4,dy - dy/2);
    cgm_polygon(4*dx  + dx/2,dy - dy/2);
    cgm_end_polygon();


    /* box 6: test circle */

    cgm_edge_color(6);

    cgm_interior_style(EMPTY);
    cgm_edge_width(25);
    cgm_circle(5*dx + dx/2, dy/2, dx/4);

    /* box 7: test circular arc center*/

    cgm_line_color(6);

    cgm_circular_arc_center(6*dx + dx/2, dy/2,1000,0,0,1000,dx/4);

    /* box 8: test circular arc center close pie*/

    cgm_edge_color(7);

    cgm_circular_arc_center_close(7*dx + dx/2, dy/2,1000,0,0,1000,dx/4,PIE);

    /* box 9: test circular arc center close chord*/

    cgm_edge_color(8);

    cgm_circular_arc_center_close(dx/2,dy + dy/2,1000,-1000,0,1000,dx/4,CHORD);


    /* box 10: test 3 pt arc*/
    cx = dx + dx/2;
    cy = dy + dy/2;

    cgm_line_color(9);

    cgm_circular_arc_3pt( cx + dx/4, cy,cx, cy + dy/4,cx - dx/4,cy);


    /* box 11: test 3 pt arc close pie*/
    cx = 2*dx + dx/2;
    cy = dy + dy/2;

    cgm_edge_color(10);

    cgm_circular_arc_3pt_close( cx + dx/4, cy,cx, cy + dy/4,cx,cy -dy/4,PIE);

    /* box 12: test 3 pt arc close chord*/
    cx = 3*dx + dx/2;
    cy = dy + dy/2;

    cgm_edge_color(11);

    cgm_circular_arc_3pt_close( cx + dx/4, cy,cx, cy + dy/4,cx,cy -dy/4,CHORD);


    /* box 13: test ellipse*/
    cx = 4*dx + dx/2;
    cy = dy + dy/2;

    cgm_edge_color(12);

    cgm_ellipse( cx,cy,cx + dx/2 - dx/8,cy ,cx,cy  + dy/8);

    /* box 14: test ellipical arc */
    cx = 5*dx + dx/2;
    cy = dy + dy/2;

    cgm_line_color(13);

    cgm_elliptical_arc( cx,cy,cx + dx/2 - dx/8,cy ,cx,cy+ dy/8,100,0,0,-100);

    /* box 15: test ellipical arc close pie */
    cx = 6*dx + dx/2;
    cy = dy + dy/2;

    cgm_edge_color(14);

    cgm_elliptical_arc_close( cx,cy,cx + dx/2 - dx/8,cy ,cx,cy+ dy/8,
                              100,0,0,100,PIE);

    /* box 16: test ellipical arc close chord*/
    cx = 7*dx + dx/2;
    cy = dy + dy/2;

    cgm_edge_color(15);

    cgm_elliptical_arc_close( cx,cy,cx + dx/2 - dx/8,cy ,cx,cy+ dy/8,
                              100,0,0,100,CHORD);


    /* box 17: test rotated ellipse*/
    cx = dx/2;
    cy = 2*dy + dy/2;

    cgm_edge_color(1);

    cgm_ellipse( cx,cy,cx + dx/3,cy +dx/3 ,cx - dx/8,cy + dx/8);



    /* box 18: test rotated elliptical arc*/
    cx = dx + dx/2;
    cy = 2*dy + dy/2;

    cgm_line_color(2);

    cgm_elliptical_arc( cx,cy,cx + dx/3,cy +dx/3 ,cx - dx/8,cy + dx/8,
                              100,0,0,-100);


    /* box 19: test rotated elliptical arc close pie*/
    cx = 2*dx + dx/2;
    cy = 2*dy + dy/2;

    cgm_edge_color(3);

    cgm_elliptical_arc_close( cx,cy,cx + dx/3,cy +dx/3 ,cx - dx/8,cy + dx/8,
                              100,0,0,-100,PIE);

    /* box 20: test rotated elliptical arc close chord*/
    cx = 3*dx + dx/2;
    cy = 2*dy + dy/2;

    cgm_edge_color(4);

    cgm_elliptical_arc_close( cx,cy,cx + dx/3,cy +dx/3 ,cx - dx/8,cy + dx/8,
                              100,0,-100,100,CHORD);


    /* box 21: test clip rectange*/
    cx = 4*dx + dx/2;
    cy = 2*dy + dy/2;

    cgm_edge_color(5);


    cgm_interior_style(SOLID);
    cgm_clip_rectangle(cx,cy,cx + dx/2,cy + dy/2);
    cgm_clip(ON);
    cgm_circle(cx,cy,dx/3);
    cgm_clip(OFF);

    /* box 22: test fonts, font list must have at least 4 fonts*/
    cx = 5*dx + dx/2;
    cy = 2*dy + dy/2;
    bdy = dy/5;

    cgm_text_color(1);

    cgm_char_height(dx/8);
    cgm_char_orientation(0,100,100,0);
    cgm_text_alignment(CENTER,HALF,0,0);
    for( k = 1; k <= 4; k++)
    {
       cgm_text_font_index(k);
       cgm_text(cx, cy - dy/2 +k*bdy,FINAL,font_list[k -1]);       
    }

    /* box 23: test text orintation*/
    cx = 6*dx + dx/2;
    cy = 2*dy + dy/2;
    bdy = dy/5;

    cgm_text_color(1);

    cgm_char_height(dx/10);
    cgm_text_font_index(1);

    cgm_text_alignment(LEFT,HALF,0,0);

    cgm_char_orientation(0,100,100,0);            /* 0  */
    cgm_text(cx,cy, FINAL," VCGM");       
    cgm_char_orientation(-100,100,100,100);       /* 45 */
    cgm_text(cx,cy, FINAL," VCGM");       
    cgm_char_orientation(-100,0,0,100);           /* 90 */
    cgm_text(cx,cy, FINAL," VCGM");       
    cgm_char_orientation(-100,-100,-100,100);     /* 135 */
    cgm_text(cx,cy, FINAL," VCGM");       
    cgm_char_orientation(0,-100,-100,0);          /* 180 */
    cgm_text(cx,cy, FINAL," VCGM");       
    cgm_char_orientation(100,-100,-100,-100);     /* 225 */
    cgm_text(cx,cy, FINAL," VCGM");       
    cgm_char_orientation(100,0,0,-100);           /* 270 */
    cgm_text(cx,cy, FINAL," VCGM");       
    cgm_char_orientation(100,100,100,-100);       /* 315 */
    cgm_text(cx,cy, FINAL," VCGM");       



    /* box 24: test restricted text*/
    cx = 7*dx + dx/2;
    cy = 2*dy + dy/2;

    cgm_text_color(1);

    cgm_char_height(dx/2);
    cgm_text_font_index(1);

    cgm_text_alignment(LEFT,HALF,0,0);

    cgm_char_orientation(0,100,100,0);            /* 0  */
    cgm_restricted_text(3*dx/8,dy/2,cx,cy, FINAL," VCGM");       
    cgm_char_orientation(-100,0,0,100);           /* 90 */
    cgm_restricted_text(3*dx/8,dy/2,cx,cy, FINAL," VCGM");       
    cgm_char_orientation(0,-100,-100,0);          /* 180 */
    cgm_restricted_text(3*dx/8,dy/2,cx,cy, FINAL," VCGM");
    cgm_char_orientation(100,0,0,-100);           /* 270 */
    cgm_restricted_text(3*dx/8,dy/2,cx,cy, FINAL," VCGM");       

    /* box 25: test char expansion factor*/
    cx = dx/2;
    cy = 3*dy + dy/2;
    bdy = dy/4;

    cgm_text_color(1);

    cgm_char_height(dx/10);
    cgm_text_font_index(1);
    cgm_text_alignment(CENTER,HALF,0,0);
    cgm_char_orientation(0,100,100,0);

    cgm_char_expansion(0x00010000L);
    cgm_text(cx,cy -dy/2 + bdy,FINAL,"Expand");
    cgm_char_expansion(0x00018000L);
    cgm_text(cx,cy -dy/2 + 2*bdy,FINAL,"Expand");
    cgm_char_expansion(0x00020000L);
    cgm_text(cx,cy -dy/2 + 3*bdy,FINAL,"Expand");
    cgm_char_expansion(0x00010000L);


    /* box 26: test char spacing*/
    cx = dx + dx/2;
    cy = 3*dy + dy/2;
    bdy = dy/4;
    cgm_char_height(dx/10);

    cgm_char_spacing(0x00000000L);
    cgm_text(cx,cy -dy/2 + bdy,FINAL,"Spacing");
    cgm_char_spacing(0x00004000L);
    cgm_text(cx,cy -dy/2 + 2*bdy,FINAL,"Spacing");
    cgm_char_spacing(0x00008000L);
    cgm_text(cx,cy -dy/2 + 3*bdy,FINAL,"Spacing");
    cgm_char_spacing(0x00000000L);


    /* box 27: test text path*/
    cx = 2*dx + dx/2;
    cy = 3*dy + dy/2;
    bdy = dy/4;
    cgm_char_height(dx/10);
    cgm_text_path(TP_RIGHT);
    cgm_text(cx,cy,FINAL," Right");
    cgm_text_path(TP_LEFT);
    cgm_text(cx,cy,FINAL," Left");
    cgm_text_path(TP_UP);
    cgm_text(cx,cy,FINAL," Up");
    cgm_text_path(TP_DOWN);
    cgm_text(cx,cy,FINAL," Down");
    cgm_text_path(TP_RIGHT);

    /* box 28: test append test*/
    cx = 3*dx + dx/2;
    cy = 3*dy + dy/2;
    bdy = dy/4;    

    cgm_text_color(3);

    cgm_char_height(dx/10);
    cgm_text(cx,cy,NON_FINAL,"Append ");
    cgm_append_text(FINAL,"Text");

    /* box 29: test polygon set */
    cx = 4*dx + dx/2;
    cy = 3*dy + dy/2;
    bdy = dy/4;
    cgm_edge_type(DOT);

    cgm_edge_color(5);
    cgm_fill_color(8);


    buf[0] = cx -dx/4;
    buf[1] = cy -dy/4;
    buf[2] = VISIBLE;
    buf[3] = cx -dx/4;
    buf[4] = cy +dy/4;
    buf[5] = VISIBLE;
    buf[6] = cx +dx/4;
    buf[7] = cy +dy/4;
    buf[8] = VISIBLE;
    buf[9]  = cx +dx/4;
    buf[10] = cy -dy/4;
    buf[11] = CLOSE_VISIBLE;


    buf[12] = cx -dx/3;
    buf[13] = cy -dy/3;
    buf[14] = VISIBLE;
    buf[15] = cx -dx/3;
    buf[16] = cy +dy/3;
    buf[17] = VISIBLE;
    buf[18] = cx +dx/3;
    buf[19] = cy +dy/3;
    buf[20] = VISIBLE;
    buf[21]  = cx +dx/3;
    buf[22] = cy -dy/3;
    buf[23] = CLOSE_VISIBLE;
    cgm_polygon_set(8,buf);



    /* box 30: test GDP (third order bezier curve id = -1000) */
    cx = 5*dx + dx/2;
    cy = 3*dy + dy/2;

    cgm_line_color(1);

    cgm_line_width(50);
    cgm_line_type(SOLID);

    buf[0] = cx -dx/3;
    buf[1] = cy;
    buf[2] = cx -dx/5;
    buf[3] = cy +dy/3;
    buf[4] = cx +dx/5;
    buf[5] = cy -dy/3;
    buf[6] = cx +dx/3; 
    buf[7] = cy;
    cgm_gdp(-1000,4,buf,0,"\0");

    /* box 31: test edge type,circle */
    cx = 6*dx + dx/2;
    cy = 3*dy + dy/2;

    cgm_edge_color(1);

    cgm_edge_width(20);
    cgm_interior_style(EMPTY);

    cgm_edge_type(1);
    cgm_circle(cx,cy,dx*7/16);
    cgm_edge_type(2);
    cgm_circle(cx,cy,dx*6/16);
    cgm_edge_type(3);
    cgm_circle(cx,cy,dx*5/16);
    cgm_edge_type(4);
    cgm_circle(cx,cy,dx*4/16);
    cgm_edge_type(5);
    cgm_circle(cx,cy,dx*3/16);

    /* box 32: test edge type, rectangle */
    cx = 7*dx + dx/2;
    cy = 3*dy + dy/2;

    cgm_edge_color(3);

    cgm_edge_type(1);
    cgm_rectangle(cx - dx*7/16,cy - dy*7/16, cx + dx*7/16,cy + dy*7/16 );
    cgm_edge_type(2);
    cgm_rectangle(cx - dx*6/16,cy - dy*6/16, cx + dx*6/16,cy + dy*6/16 );
    cgm_edge_type(3);
    cgm_rectangle(cx - dx*5/16,cy - dy*5/16, cx + dx*5/16,cy + dy*5/16 );
    cgm_edge_type(4);
    cgm_rectangle(cx - dx*4/16,cy - dy*4/16, cx + dx*4/16,cy + dy*4/16 );
    cgm_edge_type(5);
    cgm_rectangle(cx - dx*3/16,cy - dy*3/16, cx + dx*3/16,cy + dy*3/16 );


    /* box 33: test char orientation up and base not 90 degrees */
    cx =  dx/2;
    cy = 4*dy + dy/2;

    cgm_text_color(1);

    cgm_char_height(dy/6);
    cgm_text_font_index(1);
    cgm_text_alignment(CENTER,HALF,0,0);
    cgm_char_orientation(707,707,1000,0);
    cgm_text(cx,cy,FINAL,"Skewed");
    cgm_char_orientation(0,100,100,0);

    /* box 34: test zero length append */
    cx = dx + dx/2;
    cy = 4*dy + dy/2;

    cgm_char_height(dy/10);

    cgm_text(cx,cy,NON_FINAL,"Zero Append");
    cgm_append_text(FINAL,"");


    /* box 35: test trans on */
    cx = 2*dx + dx/2;
    cy = 4*dy + dy/2;
    cgm_interior_style(HATCH);
    cgm_hatch_index(1);
    cgm_circle(cx,cy,dx/3);
    cgm_hatch_index(2);
    cgm_circle(cx,cy,dx/6);


    /* box 36: test trans off */
    cx = 3*dx + dx/2;
    cy = 4*dy + dy/2;
    cgm_transparency(OFF);

    cgm_hatch_index(1);
    cgm_circle(cx,cy,dx/3);
    cgm_hatch_index(2);
    cgm_circle(cx,cy,dx/6);
    cgm_transparency(ON);

    /* box 37: test G1 character set */
    cx = 4*dx + dx/2;
    cy = 4*dy + dy/2;
    cgm_char_height(dx/5);
    cgm_text_alignment(CENTER,HALF,0,0);
    cgm_char_orientation(0,100,100,0);
    cgm_text(cx,cy,FINAL,G1teststr);

    /* box 38: privite test hatch */
    bnx = 5;
    bdx = dx/bnx;
    cx = 5*dx;
    cy = 4*dy;

    cgm_interior_style(HATCH);
    cgm_edge_vis(ON);
    cgm_edge_type(1);
    cgm_fill_color(1);
    cgm_edge_color(1);

    for(k = 0; k < bnx; k++)
    {
         cgm_hatch_index(-k -1);
         cgm_rectangle(cx + k*bdx,cy, cx + (k+1)*bdx,cy +dy/2);
    }
    for(k = 0; k < bnx; k++)
    {
         cgm_hatch_index(-k -6);
         cgm_rectangle(cx + k*bdx,cy + dy/2, cx + (k+1)*bdx,cy +dy);
    }

    /* box 39: test hatch continued */

    cgm_aux_color(5);

    cx = 6*dx;
    for(k = 0; k < bnx; k++)
    {
         cgm_hatch_index(-k -11);
         cgm_rectangle(cx + k*bdx,cy, cx + (k+1)*bdx,cy +dy/2);
    }
    for(k = 0; k < bnx; k++)
    {
         cgm_hatch_index(-k -16);
         cgm_rectangle(cx + k*bdx,cy + dy/2, cx + (k+1)*bdx,cy +dy);
    }

    cgm_aux_color(0);

    /* box 40: test marker style (-1 to -9) */
    bny = 5;
    bdy = dy/(bny +1);
    cx = 7*dx;

    cgm_marker_color(4);

    cgm_marker_size(bdy/2);

    for(k = 0; k < bny; k++)
    {
         cgm_marker_type(-k -1);
         cgm_marker( cx + dx/3,bdy*(k +1) +cy);
    }
    for(k = 0; k < 4; k++)
    {
         cgm_marker_type(-k -6);
         cgm_marker( cx + 2*dx/3,bdy*(k +1) +cy);
    }


    /* box 41: line type with transpency off */
    cx =  dx/2;
    cy = 5*dy;

    cgm_line_color(3);

    bny = 5;
    bdy = dy/(bny +1);
    cgm_line_width(50);
    cgm_transparency(OFF);
    cgm_fill_color(7);

    cgm_interior_style(SOLID);
    cgm_edge_vis(OFF);
    cgm_rectangle(0,cy,dx,cy+dy);
    for(k = 0; k < bny; k++)
    {
         cgm_line_type(k+1);
         cgm_line( dx/8, bdy*(k +1) +cy, dx - dx/8,bdy*(k +1) + cy);
    }
    cgm_transparency(ON);





    /* all other elements */

    cgm_pattern_index(1);
    cgm_text_precision(STROKE);
    cgm_escape(-100,5,"12345");
    cgm_message(NO_ACTION,"Hi There");
    cgm_application_data(-101,8,"12345678");

    cgm_end_picture();              /* end of picture, can write other pictures
                                   /* with the begin-end picture functions */
    cgm_end_metafile();            /* writes end metafile element and closes the
                                      file */
    return(0);

}

