/********************************** pars4.c *********************************/

#include <stdio.h>
#include "cgmparse.h"
#include "chkcgm.h"


static char *blen = "<<* Too Few Bytes *>";
static char *nsup = "<<* Not Supported *>>";
static char *badstate = "<<* Bad State *>>";
static char *Edge_flag[] = { "Invisible","Visible",
                             "Close Invisible","Close Visible"};


char *Class4[] = { "<<* Bad ID *>>",
                   "Polyline",
                   "Disjoint Polyline",
                   "Polymarker",
                   "Text",
                   "Restricted Text",
                   "Append Text",
                   "Polygon",
                   "Polygon Set",
                   "Cell Array",
                   "GDP",
                   "Rectangle",
                   "Circle",
                   "3 Point Arc",
                   "3 Point Arc Close",
                   "Circular Arc Center",
                   "Circular Arc Center Close",
                   "Ellipse",
                   "Elliptical Arc",
                   "Elliptical Arc Close"
                 };

void cgm_pars4(void)
{
   int p1,p2,p3,p4,p5,p6,p7,p8,buf[8];


    if ( (cgm_header.id <= MAXCLASS4ID) && (cgm_header.id > 0) )
    {
        fprintf(out,"\n%s",Class4[cgm_header.id]);
        if (!get_look_up(cgm_header.class,cgm_header.id) && mfList)
           fprintf(out,"<<* Not in Metafile Elements List *>>");
    }
    else
       fprintf(out,"\n Class 4 , ID Error (%d)",cgm_header.id);
    if (state != 4)
       fprintf(out," %s",badstate);

    if (verbose == 0)
    {
       fprintf(out," [%d bytes] ",cgm_header.length);
       return;
    }
    switch(cgm_header.id)
    {
        case 1: /*Polyline*/
        case 2: /*Disjont Polyline*/
        case 3: /*Polymarker*/
        case 7: /*Polygon*/
               while(1)
               {
                   for( ; cgm_header.length >3 ; )
                   {
                       p1 = cgm_oneival();  /* x */
                       p2 = cgm_oneival();  /* y */
                       fprintf(out,"\n     (%d,%d)",p1,p2);
                   }
                   if( cgm_header.length != 0)
                   {
                       fprintf(out," %s",blen);
                       return;
                   }
                   if (cgm_header.partition)
                   {
                       cgm_header.length = _cgm_oneival();
                       if ( cgm_header.length & 0x8000)
                           cgm_header.length &= 0x7fff;
                       else
                           cgm_header.partition = 0; 
                   }
                   else
                       break;
               }
               break;

        case 4:  /*Text*/

               if( cgm_header.length < 7)
               {
                   fprintf(out," %s",blen);
                   return;
               }

               p1 = cgm_oneival();   /* x */
               p2 = cgm_oneival();   /* y */
               p3 = cgm_oneival();   /* final flag */
               if (p3 == 0)
                   fprintf(out," (%d,%d) Not Final",p1,p2);
               else if (p3 == 1)
                   fprintf(out," (%d,%d) Final",p1,p2);
               else 
                   fprintf(out," (%d,%d) Flag Error",p1,p2);
               cgm_read_string();
               fprintf(out," \"%s\"",cgm_cbuffer);
               break;


        case 5:  /* Resticted Text*/

               if( cgm_header.length < 11)
               {
                   fprintf(out," %s",blen);
                   return;
               }                        
               p1 = cgm_oneival(); /* delta width */
               p2 = cgm_oneival(); /* delta height */
               p3 = cgm_oneival(); /* x */
               p4 = cgm_oneival(); /* y */
               p5 = cgm_oneival(); /* final flag */
               if (p5 == 0)
                  fprintf(out,"  [%d] [%d] (%d,%d) Not Final",p1,p2,p3,p4);
               else if (p5 == 1)
                  fprintf(out," [%d] [%d] (%d,%d) Final",p1,p2,p3,p4);
               else 
                  fprintf(out," [%d] [%d] (%d,%d) Flag Error",p1,p2,p3,p4);
               cgm_read_string();
               fprintf(out," \"%s\"",cgm_cbuffer);            
               break;
            
        case 6:  /* Append Text*/

               if( cgm_header.length < 3)
               {
                   fprintf(out," %s",blen);
                   return;
               }                        
               p1 = cgm_oneival(); /* final flag */
               if (p1 == 0)
                  fprintf(out," Not Final");
               else if (p1 == 1)
                  fprintf(out," Final");
               else 
                  fprintf(out," Flag Error");
               cgm_read_string();
               fprintf(out," \"%s\"",cgm_cbuffer);
               break;

        case 8:  /* Polygon Set*/
               while(1)
               {
                   for( ; cgm_header.length >5 ; )
                   {
                       p1 = cgm_oneival(); /* x */
                       p2 = cgm_oneival(); /* y */
                       p3 = cgm_oneival(); /* edge out flag */
                       if ( (p3 < 0) || (p3 > 3) )
                          fprintf(out,"\n     (%d,%d) Bad Flag %d",p1,p2,p3);
                       else
                          fprintf(out,"\n     (%d,%d) %s ",p1,p2,Edge_flag[p3]);
                   }
                   if (cgm_header.partition)
                   {
                       cgm_header.length = _cgm_oneival();
                       if ( cgm_header.length & 0x8000)
                          cgm_header.length &= 0x7fff;
                       else
                          cgm_header.partition = 0;
                   }
                   else
                       break;
               }
               break;

        case 9:  /* Cell Array*/
               fprintf(out," %s",nsup);
               break;

       case 10:  /* GDP*/
               if( cgm_header.length < 4)
               {
                   fprintf(out," %s",blen);
                   return;
               }                        
     
               p1 = cgm_oneival(); /* id */
               p2 = cgm_oneival(); /* num points */
               fprintf(out," ID = %d, Num Points = %d ",p1,p2);
               while(1)
               {
                    for( ; cgm_header.length >3 ; )
                    {
                        if (p2 <= 0)
                           break;
                        p3 = cgm_oneival(); /* get x */
                        p4 = cgm_oneival(); /* get y */
                        fprintf(out,"\n     (%d,%d)",p3,p4);
                        p2--;
                    }
                    if (cgm_header.partition)
                    {
                        cgm_header.length = _cgm_oneival();
                        if ( cgm_header.length & 0x8000)
                            cgm_header.length &= 0x7fff;
                        else
                            cgm_header.partition = 0;
                    }
                    else
                       break;
               }
               if(hex)
                   read_hex();
               else
               {
                   cgm_read_string();
                   fprintf(out,"\n \"%s\"",cgm_cbuffer);
               }
               break;
                     
       case 11:  /* Rectangle*/

               if( cgm_header.length < 8)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_read_integers(8,buf); /* test function */
               if( p1 != 4)
                   fprintf(out," Data Error");
     
                /* buf[0] x1 */
                /* buf[1] y1 */
                /* buf[2] x2 */
                /* buf[3] y2 */

               fprintf(out," (%d,%d) (%d,%d)",
                   buf[0],buf[1],buf[2],buf[3]);
               break;

       case 12:  /* Circle*/
               if( cgm_header.length < 6)
               {
                   fprintf(out," %s",blen);
                   return;
               }

               p1 = cgm_oneival(); /* x */
               p2 = cgm_oneival(); /* y */
               p3 = cgm_oneival(); /* radius */
               fprintf(out," (%d,%d) [%d]",p1,p2,p3);
               break;


       case 13:  /* 3 point Arc*/
              if( cgm_header.length < 12)
              {
                 fprintf(out," %s",blen);
                 return;
              }
              p1 = cgm_oneival(); /* starting pt, x */
              p2 = cgm_oneival(); /* starting pt, y */
              p3 = cgm_oneival(); /* intermediate pt, x */
              p4 = cgm_oneival(); /* intermediate pt, y */
              p5 = cgm_oneival(); /* ending pt, x */
              p6 = cgm_oneival(); /* ending pt, y */
              fprintf(out," (%d,%d) (%d,%d) (%d,%d)",p1,p2,p3,p4,p5,p6);
              break;


       case 14:  /* 3 point Arc Close*/
              if( cgm_header.length < 14)
              {
                  fprintf(out," %s",blen);
                  return;
              }
              p1 = cgm_oneival();  /* starting pt, x */
              p2 = cgm_oneival();  /* starting pt, y */
              p3 = cgm_oneival();  /* intermediate pt, x */
              p4 = cgm_oneival();  /* intermediate pt, y */
              p5 = cgm_oneival();  /* ending pt, x */
              p6 = cgm_oneival();  /* ending pt, y */
              p7 = cgm_oneival();  /* arc closure type */
              if (p7 == 0)
                 fprintf(out," (%d,%d) (%d,%d) (%d,%d) Pie",p1,p2,p3,p4,p5,p6);
              else if (p7 == 1)
                 fprintf(out," (%d,%d) (%d,%d) (%d,%d) Chord",
                                  p1,p2,p3,p4,p5,p6);
              else 
                 fprintf(out," (%d,%d) (%d,%d) (%d,%d) Bad Flag",
                                  p1,p2,p3,p4,p5,p6);
              break;

       case 15:  /* Center Arc */
       case 16:  /* Center Arc Close */
              if( cgm_header.length < 14)
              {
                  fprintf(out," %s",blen);
                  return;
              }
              p1 = cgm_oneival();  /* x */
              p2 = cgm_oneival();  /* y */
              p3 = cgm_oneival();  /* dx start vector */
              p4 = cgm_oneival();  /* dy start vector */
              p5 = cgm_oneival();  /* dx end vector */
              p6 = cgm_oneival();  /* dy end vector */
              p7 = cgm_oneival();  /* radius */
              fprintf(out,"\n     (%d,%d) <%d,%d> <%d,%d> [%d] ",
                             p1,p2,p3,p4,p5,p6,p7);
              if(cgm_header.id == 16)
              {
                  if( cgm_header.length < 2)
                  {
                      fprintf(out," %s",blen);
                      return;
                  }
                  p8 = cgm_oneival(); /* arc closure type */
                  if (p8 == 0)
                     fprintf(out," Pie");
                  else if (p8 == 1)
                     fprintf(out," Chord");
                  else 
                     fprintf(out," Flag Error");
              }
              break;

       case 17:  /* Ellipse */
              if( cgm_header.length < 12)
              {
                 fprintf(out," %s",blen);
                 return;
              }
              p1 = cgm_oneival(); /* center x */
              p2 = cgm_oneival(); /* center y */
              p3 = cgm_oneival(); /* first conjugate diameter end pt, x */
              p4 = cgm_oneival(); /* first conjugate diameter end pt, y */
              p5 = cgm_oneival(); /* second conjugate diameter end pt, x */
              p6 = cgm_oneival(); /* second conjugate diameter end pt, y */
              fprintf(out," (%d,%d) (%d,%d) (%d,%d) ",p1,p2,p3,p4,p5,p6);
              break;


       case 18:  /* Elliptical Arc*/
       case 19:  /* Elliptical Arc Close*/
              if( cgm_header.length < 20)
              {
                  fprintf(out," %s",blen);
                  return;
              }

              p1 = cgm_oneival(); /* center x */
              p2 = cgm_oneival(); /* center y */
              p3 = cgm_oneival(); /* first conjugate diameter end pt, x */
              p4 = cgm_oneival(); /* first conjugate diameter end pt, y */
              p5 = cgm_oneival(); /* second conjugate diameter end pt, x */
              p6 = cgm_oneival(); /* second conjugate diameter end pt, y */
              fprintf(out,
                  "\n     (%d,%d) (%d,%d) (%d,%d)",p1,p2,p3,p4,p5,p6);
              p1 = cgm_oneival(); /* dx start vector */
              p2 = cgm_oneival(); /* dy start vector */
              p3 = cgm_oneival(); /* dx end vector */
              p4 = cgm_oneival(); /* dy end vector */
              fprintf(out," <%d,%d> <%d,%d>",p1,p2,p3,p4);
              if (cgm_header.id == 19)
              {
                  if( cgm_header.length < 2)
                  {
                      fprintf(out," %s",blen);
                      return;
                  }
                  p1 = cgm_oneival();  /* arc closure type */
                  if(p1 == 0)
                      fprintf(out," Pie");
                  else if (p1 == 1)
                      fprintf(out," Chord");
                  else
                      fprintf(out," Bad Value");
              }
              break;
    }
             
}
