/********************************** pars5.c *********************************/

#include <stdio.h>
#include "cgmparse.h"
#include "chkcgm.h"

static char *blen = "<<* Too Few Bytes *>>";
static char *nsup = "<<* Not Supported *>>";
static char *badstate = "<<* Bad State *>>";
static char *linetype[] = {"<<* Bad Value *>>","Solid","Dash","Dot","Dash-dot",
                         "Dash-dot-dot"};

static char *markertype[] = {"<<* Bad Value *>>","Dot","Plus","Asterisk","Circle",
                         "Cross"};
static char *textprec[] = {"String","Character","Stroke"};

static char *textpath[] = {"Right","Left","Up","Down"};
static char *horalign[] = {"Normal","Left","Center","Right","Continuous"};
static char *vertalign[] = {"Normal","Top","Cap","Half","Base","Bottom",
                            "Continuous"}; 

static char *interior[] = {"Hollow","Solid","Pattern","Hatch","Empty"}; 
static char *hatch[] = {"<<* Bad Value *>>","Horizontal","Vertical","Positive Slope",
                        "Negitive Slope","Vertical and Horizontal Slant",
                         "Left and Right Slant"}; 

char *Class5[] = { "<<* Bad ID *>>",                   
                   "Line Bundle Index",
                   "Line Type",
                   "Line Width",
                   "Line Color",
                   "Marker Bundle Index",
                   "Marker Type",
                   "Marker Size",
                   "Marker Color",
                   "Text Bundle Index",
                   "Text Font Index",
                   "Text Precision",
                   "Character Expansion Factor",
                   "Character Spacing",
                   "Text Color",
                   "Character Height",
                   "Character Orientation",
                   "Text Path",
                   "Text Alignment",
                   "Character Set Index",
                   "Alternate Character Set Index",
                   "Fill Bundle Index",
                   "Interior Style",
                   "Fill Color",
                   "Hatch Index",
                   "Pattern Index",
                   "Edge Bundle Index",
                   "Edge Type",
                   "Edge Width",
                   "Edge Color",
                   "Edge Visiblity",
                   "Fill Reference Point",
                   "Pattern Table",
                   "Pattern Size",
                   "Color Table",
                   "Aspect Source Flags"
                };

void cgm_pars5(void)
{
   int p1,p2,p3,p4,rgb[3];
   long r1,r2;

   if ( (cgm_header.id <= MAXCLASS5ID) && (cgm_header.id > 0) )
   {
       fprintf(out,"\n%s",Class5[cgm_header.id]);
       if (!get_look_up(cgm_header.class,cgm_header.id) && mfList)
          fprintf(out," <<* Not in Metafile Elements List *>>");
   }
   else
       fprintf(out,"\n Class 5 , ID Error (%d)",cgm_header.id);
   if (state != 4)
      fprintf(out," %s",badstate);

   switch(cgm_header.id)
   {
       case  1: /* Line Bundle Index */
       case  5: /* Marker Bundle Index */
       case  9: /* Text Bundle Index */
       case 26: /* Edge Bundle Index */
       case 21: /* Fill Bundle Index */
               if( cgm_header.length < 2)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival();
               fprintf(out," %d %s",p1,nsup);
               break;

       case 2 : /*Line Type*/
       case 27: /*Edge Type*/
               if( cgm_header.length < 2)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival();
               if ( p1 > 0)
               {
                   if (p1 <= 5)
                      fprintf(out," %s",linetype[p1]);
                   else
                      fprintf(out," Registration Req. (%d)",p1);
               }
               else
                   fprintf(out," Private (%d)",p1);
               break;

        case 4: /* Line Color */
        case 8: /* Marker Color */
       case 14: /* Text Color */
       case 23: /* Fill Color */
       case 29: /* Edge Color*/

               if ( cgm_color_mode_in == 1)
               { /* direct */
                   if( cgm_read_rgb_color(rgb) < 0)
                   {
                       fprintf(out," %s",blen);
                       break;
                   }
                   fprintf(out," {%d,%d,%d}",rgb[0],rgb[1],rgb[2]);
               }
               else
               {  /* index */
                  p1 = cgm_read_color_index(); 
                  if( p1 < 0)
                  {
                      fprintf(out," %s",blen);
                      break;
                  }             
                  fprintf(out," %d",p1);
               }
               break;

 
        case 3: /*Line Width*/
               if(LineScaleMode)
               {
                   if( cgm_header.length < 4)
                   {
                       fprintf(out," %s",blen);
                       return;
                   }
                   r1 = cgm_onerval();
                   fprintf(out," %f",FixedtoFloat(r1));
               }
               else
               {
                   if( cgm_header.length < 2)
                   {
                       fprintf(out," %s",blen);
                       return;
                   }
                   p1 = cgm_oneival();
                   fprintf(out," %d",p1);    
               }
               break;

        case 7: /* Marker Size */
               if(MarkerScaleMode)
               {
                   if( cgm_header.length < 4)
                   {
                       fprintf(out," %s",blen);
                       return;
                   }
                   r1 = cgm_onerval();
                   fprintf(out," %f",FixedtoFloat(r1));
               }
               else
               {
                   if( cgm_header.length < 2)
                   {
                       fprintf(out," %s",blen);
                       return;
                   }
                   p1 = cgm_oneival();
                   fprintf(out," %d",p1);    
               }
               break;

        case 28: /* Edge Width*/

               if(EdgeScaleMode)
               {
                   if( cgm_header.length < 4)
                   {
                       fprintf(out," %s",blen);
                       return;
                   }
                   r1 = cgm_onerval();
                   fprintf(out," %f",FixedtoFloat(r1));
               }
               else
               {
                   if( cgm_header.length < 2)
                   {
                       fprintf(out," %s",blen);
                       return;
                   }
                   p1 = cgm_oneival();
                   fprintf(out," %d",p1);    
               }
               break;

       case 10: /* Text Font Index */
       case 15: /* Character Heigth */
       case 19: /* Character Set Index */
       case 20: /* Alt. Character Set Index */
       case 25: /* pattern Index */
               if( cgm_header.length < 2)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival();
               fprintf(out," %d",p1);
               break;

        case 6: /* Marker Type */
               if( cgm_header.length < 2)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival();
               if ( p1 > 0)
               {
                   if (p1 <= 5)
                      fprintf(out," %s",markertype[p1]);
                   else
                      fprintf(out," Registration Req. (%d)",p1);
               }
               else
                   fprintf(out," Private (%d)",p1);
               break;

       case 11: /* Text Precision */
               if( cgm_header.length < 2)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival();
               if ( (p1 <= 2) && (p1 >= 0) )
                   fprintf(out," %s",textprec[p1]);
               else
                   fprintf(out," <<* Bad Value *>> (%d)",p1);
               break;

       case 12: /* Character Expansion Factor */
       case 13: /* Character Spacing */
               if( cgm_header.length < 4)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               r1 = cgm_onerval();
               fprintf(out," %f",FixedtoFloat(r1));
               break;

       case 16: /*Character Orientation*/
               if( cgm_header.length < 8)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival(); /* up vector, x */
               p2 = cgm_oneival(); /* up vector, y */
               p3 = cgm_oneival(); /* base vector, x */
               p4 = cgm_oneival(); /* base vector, y */
               fprintf(out," Up <%d,%d> Base <%d,%d>",p1,p2,p3,p4);
               break;

       case 17: /* Text Path */

               if( cgm_header.length < 2)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival();
               if ( (p1 <= 3) && (p1 >= 0) )
               {
                   if( p1 == 0)
                      fprintf(out," %s ",textpath[p1]);
                   else
                      fprintf(out," %s %s",textpath[p1],nsup);
               }
               else
                  fprintf(out," <<* Bad Value *>> (%d)",p1);
               break;

       case 18: /*Text Alignment*/
               if( cgm_header.length < 12)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival(); /* horizontal alignment */
               p2 = cgm_oneival(); /* vertical alignment */
               r1 = cgm_onerval(); /* continuous horizontal alignment */
               r2 = cgm_onerval(); /* continuous vertical alignment */
               if ( (p1 <= 4) && (p1 >= 0) )
                   fprintf(out," %s ",horalign[p1]);
               else
                   fprintf(out," <<* Bad Value *>> (%d)",p1);
               if(p1 == 4)
                   fprintf(out," %f",FixedtoFloat(r1));

               if ( (p2 <= 6) && (p2 >= 0) )
                   fprintf(out," %s ",vertalign[p2]);
               else
                   fprintf(out," <<* Bad Value *>> (%d)",p2);
               if(p2 == 6)
                   fprintf(out," %f",FixedtoFloat(r2));
               break;

       case 22: /* Interior Style */
               if( cgm_header.length < 2)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival();
               if( (p1 <= 5)  && (p1 >= 0) )
                   fprintf(out," %s",interior[p1]);
               else
                   fprintf(out," Private (%d)",p1);
               break;

       case 24: /* Hatch Index */
               if( cgm_header.length < 2)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival();
               if ( p1 > 0)
               {
                   if (p1 <= 6)
                       fprintf(out," %s",hatch[p1]);
                   else
                       fprintf(out," Registration Req. (%d)",p1);
               }
               else
                   fprintf(out," Private (%d)",p1);
               break;



       case 30: /* Edge Visibility */
               if( cgm_header.length < 2)
               {
                    fprintf(out," %s",blen);
                    return;
               }
               p1 = cgm_oneival();
               if ( p1 == 0)
                   fprintf(out," Off");
               else if ( p1 == 1)
                   fprintf(out," On");
               else
                   fprintf(out," <<* Bad Value *>> (%d)",p1);
               break;

       case 31: /* Fill Reference Point */
               if( cgm_header.length < 4)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival(); /* x */
               p2 = cgm_oneival(); /* y */
               fprintf(out," (%d,%d) %s",p1,p2,nsup);
               break;

       case 33: /* Pattern Size */
               if( cgm_header.length < 8)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               p1 = cgm_oneival(); /* height vector, x */
               p2 = cgm_oneival(); /* height vector, y */
               p3 = cgm_oneival(); /* width vector, x */
               p4 = cgm_oneival(); /* width vector, x */
               fprintf(out," (%d,%d) (%d,%d) %s",p1,p2,p3,p4,nsup);
               break;

       case 34: /* Color Table */
               p1 = cgm_read_color_index(); /* start index */
               if( p1 < 0)
               {
                   fprintf(out," %s",blen);
                   return;
               }
               fprintf(out,"\n   Start Index %d",p1);
               while (cgm_read_rgb_color(rgb) >= 0 )
               {
                   fprintf(out,"\n   {%d,%d,%d}",rgb[0],rgb[1],rgb[2]);
               }
               break;

               /* not supported  */
       case 32: /* pattern Table */
       case 35: /* Aspect Source Flags */
               fprintf(out," %s",nsup);
   }
}
